package delta;

import java.awt.BorderLayout;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.StringTokenizer;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;
import javax.swing.JTextPane;


public class CharacterinfoApp extends JFrame implements ActionListener {
	private JTextPane inFld;
	private JTextPane outFld;
	private JButton showCodeBtn;
	private JButton showInfoBtn;
	private JButton extractLetterBtn;
	private JButton normalizeArabicBtn;

	public CharacterinfoApp(){
		inFld = new JTextPane();
		//inFld.setText("                   \n\n\n\n\n");
		inFld.setBorder(new javax.swing.border.TitledBorder("Input"));
		outFld = new JTextPane();
		//outFld.setText("                   \n\n\n\n\n");
		outFld.setBorder(new javax.swing.border.TitledBorder("Output"));
		JPanel fldPn = new JPanel();
		fldPn.setLayout(new GridLayout(2,1));
		fldPn.add(inFld);
		fldPn.add(outFld);
		JPanel btnPn = new JPanel();
		showCodeBtn = new JButton("Show Character Codes");
		showCodeBtn.addActionListener(this); 
		showCodeBtn.setActionCommand("c");
		showInfoBtn = new JButton("Show Character Info");
		showInfoBtn.addActionListener(this); 
		showInfoBtn.setActionCommand("i");
		extractLetterBtn = new JButton("Extract Letters");
		extractLetterBtn.addActionListener(this);
		extractLetterBtn.setActionCommand("l");
		normalizeArabicBtn = new JButton("Normalize Arabic");
		normalizeArabicBtn.addActionListener(this);
		normalizeArabicBtn.setActionCommand("n");
		btnPn.setLayout(new GridLayout(1,4));
		btnPn.add(showCodeBtn);
		btnPn.add(showInfoBtn);
		btnPn.add(extractLetterBtn);
		btnPn.add(normalizeArabicBtn);
		this.getContentPane().add(fldPn, BorderLayout.CENTER);
		this.getContentPane().add(btnPn, BorderLayout.SOUTH);
	}
	
	
	public static void main(String[] args) {
		JFrame frm = new CharacterinfoApp();
		frm.setBounds(50, 60, 800, 600);
		frm.setVisible(true);

	}


	@Override
	public void actionPerformed(ActionEvent e) {
		if ("c".equals(e.getActionCommand())){
	        showCodes();
		}else if ("i".equals(e.getActionCommand())){
	        showInfo();
		}else if ("l".equals(e.getActionCommand())){
	        removeLetter();
		}else if ("n".equals(e.getActionCommand())){
			normalizeArabicText();
		}
	}
	
	public void showCodes(){
		String inStr = inFld.getText();		
		StringBuffer outStr = new StringBuffer();
		StringTokenizer lnPrsr = new StringTokenizer(inStr, "\n\r");
		while(lnPrsr.hasMoreTokens()){
			String inLn = lnPrsr.nextToken();
			int ln= inLn.length();
			for(int i=0; i<ln; i++){
				char ch = inLn.charAt(i);
				int intVal  = (int)(ch);
				outStr.append(Integer.toHexString(intVal)+"/");
			}
			outStr.append("\n");
		}
		outFld.setText(outStr.toString());
	}
	public void showInfo(){
		String inStr = inFld.getText();	
		if(inStr.length()==0){
			return;
		}
		char ch = inStr.charAt(0);
		int intVal  = (int)(ch);
		int type = Character.getType(ch);
		//String info = Character.getName(intVal);
		//String infoStr = "no information available";
		StringBuffer infoStr = new StringBuffer();
		if(Character.isLetter(intVal)){
			infoStr.append( "is letter; ");
		}
		if(Character.isSpaceChar(intVal)){
			infoStr.append( "is space char; ");
		}
		if(Character.isDigit(intVal)){
			infoStr.append( "is digit; ");
		}
		if(type == Character.COMBINING_SPACING_MARK){
			infoStr.append( "COMBINING_SPACING_MARK; ");
		}
		if(type == Character.CONNECTOR_PUNCTUATION){
			infoStr.append( "CONNECTOR_PUNCTUATION; ");
		}
		if(type == Character.CONTROL){
			infoStr.append( "CONTROL; ");
		}
		if(type == Character.CURRENCY_SYMBOL){
			infoStr.append( "CURRENCY_SYMBOL; ");
		}
		if(type == Character.DASH_PUNCTUATION){
			infoStr.append( "DASH_PUNCTUATION; ");
		}
		if(type == Character.DECIMAL_DIGIT_NUMBER){
			infoStr.append( "DECIMAL_DIGIT_NUMBER; ");
		}
		if(type == Character.ENCLOSING_MARK){
			infoStr.append( "ENCLOSING_MARK; ");
		}
		if(type == Character.END_PUNCTUATION){
			infoStr.append( "END_PUNCTUATION; ");
		}
		if(type == Character.FINAL_QUOTE_PUNCTUATION){
			infoStr.append( "FINAL_QUOTE_PUNCTUATION; ");
		}
		if(type == Character.FORMAT){
			infoStr.append( "FORMAT; ");
		}
		if(type == Character.INITIAL_QUOTE_PUNCTUATION){
			infoStr.append( "INITIAL_QUOTE_PUNCTUATION; ");
		}
		if(type == Character.LETTER_NUMBER){
			infoStr.append( "LETTER_NUMBER; ");
		}
		if(type == Character.LINE_SEPARATOR){
			infoStr.append( "LINE_SEPARATOR; ");
		}
		if(type == Character.LOWERCASE_LETTER){
			infoStr.append( "LOWERCASE_LETTER; ");
		}
		if(type == Character.MATH_SYMBOL){
			infoStr.append( "MATH_SYMBOL; ");
		}
		if(type == Character.MODIFIER_LETTER){
			infoStr.append( "MODIFIER_LETTER; ");
		}
		if(type == Character.MODIFIER_SYMBOL){
			infoStr.append( "MODIFIER_SYMBOL; ");
		}
		if(type == Character.NON_SPACING_MARK){
			infoStr.append( "NON_SPACING_MARK; ");
		}
		if(type == Character.OTHER_LETTER){
			infoStr.append( "OTHER_LETTER; ");
		}
		if(type == Character.OTHER_NUMBER){
			infoStr.append( "OTHER_NUMBER; ");
		}
		if(type == Character.OTHER_PUNCTUATION){
			infoStr.append( "OTHER_PUNCTUATION; ");
		}
		if(type == Character.OTHER_SYMBOL){
			infoStr.append( "OTHER_SYMBOL; ");
		}
		if(type == Character.PARAGRAPH_SEPARATOR){
			infoStr.append( "PARAGRAPH_SEPARATOR; ");
		}
		if(type == Character.PRIVATE_USE){
			infoStr.append( "PRIVATE_USE; ");
		}
		if(type == Character.SPACE_SEPARATOR){
			infoStr.append( "SPACE_SEPARATOR; ");
		}
		if(type == Character.START_PUNCTUATION){
			infoStr.append( "START_PUNCTUATION; ");
		}
		if(type == Character.SURROGATE){
			infoStr.append( "SURROGATE; ");
		}
		if(type == Character.TITLECASE_LETTER){
			infoStr.append( "TITLECASE_LETTER; ");
		}
		if(type == Character.UNASSIGNED){
			infoStr.append( "UNASSIGNED; ");
		}
		if(type == Character.UPPERCASE_LETTER){
			infoStr.append( "UPPERCASE_LETTER; ");
		}
		
		
		outFld.setText("Type "+type+": "+infoStr.toString());
	}
	
	public static String extractLetters(String str){
		if(str==null){
			return null;
		}
		StringBuffer outStr = new StringBuffer();
		int ln = str.length();
		for(int i=0; i<ln; i++){
			char ch = str.charAt(i);
			if(Character.isLetter(ch)){
				outStr.append(ch);
			}
		}
		return outStr.toString();
	}
	public void removeLetter(){
		String inStr = inFld.getText();
		outFld.setText(extractLetters(inStr));
	}
	public static String extractHamzas(String str){
		if(str==null){
			return null;
		}
		StringBuffer outStr = new StringBuffer();
		int ln = str.length();
		for(int i=0; i<ln; i++){
			char ch = str.charAt(i);
			if(ch=='\u0622' || ch=='\u0623' || ch=='\u0625'){
				outStr.append('\u0627');
			}else if(ch=='\u0624'){
				outStr.append('\u0648');
			}else if(ch=='\u0626' || ch=='\u0623' || ch=='\u0625'){
				outStr.append('\u064A');
			}else if(ch=='\u0621' || ch=='\u0653' || ch=='\u0654'|| ch=='\u0655'){
				;
			}else{
				outStr.append(ch);
			}
		}
		return outStr.toString();
	}
	public void normalizeArabicText(){
		String inStr = inFld.getText();
		if(inStr==null){
			return;
		}
		StringBuffer outStr = new StringBuffer();
		StringTokenizer lnPrsr = new StringTokenizer(inStr, "\n\r");
		while(lnPrsr.hasMoreTokens()){
			String lnStr = lnPrsr.nextToken();
			StringTokenizer wdPrsr = new StringTokenizer(lnStr, " .,:;.!?");
			boolean startFlag = true;
			while(wdPrsr.hasMoreTokens()){
				String wdStr = normalizeArabic(wdPrsr.nextToken());
				if(wdStr!=null && wdStr.length()>0){
					if(!startFlag){
						outStr.append(" ");
						
					}
					startFlag = false;
					outStr.append(wdStr);
				}
			}
			outStr.append("\n");
		}
		outFld.setText(outStr.toString());
	}
	public static String normalizeArabic(String str){
		if(str==null){
			return null;
		}
		StringBuffer outStr = new StringBuffer();
		int ln = str.length();
		for(int i=0; i<ln; i++){
			char ch = str.charAt(i);
			if(ch=='\u0622' || ch=='\u0623' || ch=='\u0625'){
				outStr.append('\u0627');
			}else if(ch=='\u0624'){
				outStr.append('\u0648');
			}else if(ch=='\u0626' || ch=='\u0623' || ch=='\u0625'){
				outStr.append('\u064A');
			}else if(!Character.isLetter(ch) || ch=='\u0621' || ch=='\u0653' || ch=='\u0654'|| ch=='\u0655'){
				;
			}else if(ch=='\u0629'){
				outStr.append('\u0647');
			}else if(ch=='\u0649'){
				outStr.append('\u064A');
			}else{
				outStr.append(ch);
			}
		}
		return outStr.toString();

	}
	public void removeHamzas(){
		String inStr = inFld.getText();
		outFld.setText(extractHamzas(inStr));
	}
	public void removeHamzasTamarbutaAlifmaksura(){
		String inStr = inFld.getText();
		outFld.setText(removeAlifmaksura(removeTamarbuta(extractHamzas(inStr))));
	}

	public static String removeTamarbuta(String str){
		if(str==null){
			return null;
		}
		StringBuffer outStr = new StringBuffer();
		int ln = str.length();
		for(int i=0; i<ln; i++){
			char ch = str.charAt(i);
			if(ch=='\u0629'){
				outStr.append('\u0647');
			}else{
				outStr.append(ch);
			}
		}
		return outStr.toString();
	}
	public static String removeAlifmaksura(String str){
		if(str==null){
			return null;
		}
		StringBuffer outStr = new StringBuffer();
		int ln = str.length();
		for(int i=0; i<ln; i++){
			char ch = str.charAt(i);
			if(ch=='\u0649'){
				outStr.append('\u064A');
			}else{
				outStr.append(ch);
			}
		}
		return outStr.toString();
	}
	
	public void showCharType(){
		String inStr = inFld.getText();	
		if(inStr.length()==0){
			return;
		}
		char ch = inStr.charAt(0);
		int intVal  = (int)(ch);
		String info = "not implemented";
		// info = Character.getName(intVal); needs Java 7
		outFld.setText(info);
	}



}
