package delta;

import java.util.Vector;

public class TrainingDataEntry {
	private String word;
	private double frequency;
	private double stdev;
	private Vector<Integer> counter;
	private int allCount; 

	
	public TrainingDataEntry(String wd){
		word = wd;
		counter = new Vector<Integer>();
		counter.add(new Integer(0));
		allCount = 0;
	}
	public void increaseCount(int chunkNum){
		for(int i=counter.size()-1; i<chunkNum-1; i++){ // fill in missing chunk counters
			Integer cntr = new Integer(0);
			counter.add(cntr);
		}
		if(counter.size()<chunkNum){ // fill in acutal chunk counter
			Integer cntr = new Integer(1);
			counter.add(cntr);
		}else{
			Integer cntr = counter.get(chunkNum-1);
			counter.set(chunkNum-1, new Integer(cntr+1));
		}
		allCount++;
	}
	public void finishCounting(int chunkNum){
		for(int i=counter.size(); i<chunkNum; i++){ // fill in missing chunk counters
			Integer cntr = new Integer(0);
			counter.add(cntr);
		}
	}
	public int count(int chunkNum){
		if(counter.size()<chunkNum || chunkNum<1){
			return 0;
		}
		return counter.get(chunkNum-1).intValue();
	}
	public int getAllCount(){
		return allCount;
	}
	public void calculateMeanFrequency(Vector<Integer> chunks){
		if(chunks==null || chunks.size()<1){
			return;
		}
		int sz = counter.size();
		int count = 0; 
		for(int i=0; i<sz; i++){
			count += counter.get(i).intValue();
		}
		double allToken = 0.0;
		int chnksSize = chunks.size();
		for(int i=0; i<chnksSize; i++){
			allToken += (double)chunks.get(i);
		}
		frequency = count/allToken;
	}
	public void calculateMeanFrequency(int numOfTokens){
		frequency = (double)allCount/(double)numOfTokens;
	}
	public void calculateStdev(Vector<Integer> chunks){
		if(chunks==null || chunks.size()<1){
			return;
		}
		double allToken = 0.0;
		int chnksSize = chunks.size();
		for(int i=0; i<chnksSize; i++){
			allToken += (double)chunks.get(i);
		}

		stdev = 0.0;
		int sz = chunks.size();
		int cntrSz = counter.size();
		for(int i=0; i<sz; i++){
			if(i<cntrSz){
				double tmp = frequency - (double)counter.get(i)/(double)chunks.get(i);
				stdev += tmp*tmp;
			}else{
				
			}
		}
		stdev =stdev/(allToken-1);
		stdev=Math.sqrt(stdev);
	}

	public String toString(){
		if(word==null){
			return "";
		}
		return word+"\t"+Double.toString(frequency)+"\t"+Double.toString(stdev);
	}
	public String toVerboseString(){
		if(word==null){
			return "";
		}
		StringBuffer out = new StringBuffer();
		out.append(word+"\t"+Double.toString(frequency)+"\t"+Double.toString(stdev)); 
		int sz = counter.size();
		for(int i=0; i<sz; i++){
			out.append("\t"+counter.get(i).toString());
		}
		return out.toString();
	}

	public String getWord() {
		return word;
	}
	public void setWord(String word) {
		this.word = word;
	}
	public double getFrequency() {
		return frequency;
	}
	public void setFrequency(double frequency) {
		this.frequency = frequency;
	}
	public double getStdev() {
		return stdev;
	}
	public void setStdev(double stdev) {
		this.stdev = stdev;
	}
}
