package delta;


public class Trigram {

	public static final String WILDCARD = "_";
	public static final String SEPARATOR = " ";
	
	private String prefix;
	private String core;
	private String suffix;
	
	public Trigram(String trgrmStr){
		String [] parts = trgrmStr.split(SEPARATOR);
		if(parts.length!=3){
			return;
		}
		prefix= parts[0];
		core= parts[1];
		suffix= parts[2];
	}
	public String toString(){
		return prefix+SEPARATOR+core+SEPARATOR+suffix;
	}
	public double compareTrigrams(Trigram t1, Trigram t2){
		double score = 0.0;
		if(t2.getCore().equals(WILDCARD)){
			if(t1.getPrefix().equals(t2.getPrefix())){
				score+=0.5;
			}
			if(t1.getSuffix().equals(t2.getSuffix())){
				score+=0.5;
			}
	
		}else{
			if(t1.getPrefix().equals(t2.getPrefix())){
				score+=1.0/3.0;
			}
			if(t1.getCore().equals(t2.getCore())){
				score+=1.0/3.0;
			}
			if(t1.getSuffix().equals(t2.getSuffix())){
				score+=1.0/3.0;
			}
		}
		return score;
	}
	public boolean equals(Trigram t){
		if(!this.prefix.equals(t.getPrefix())){
			return false;
		}
		if(!this.core.equals(t.getCore())){
			return false;
		}
		if(!this.suffix.equals(t.getSuffix())){
			return false;
		}
		return true;
	}
	
	public String getPrefix() {
		return prefix;
	}
	public void setPrefix(String prefix) {
		this.prefix = prefix;
	}
	public String getCore() {
		return core;
	}
	public void setCore(String core) {
		this.core = core;
	}
	public String getSuffix() {
		return suffix;
	}
	public void setSuffix(String suffix) {
		this.suffix = suffix;
	}
}
